/*
 * Copyright 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <config.h>

#if defined(CONFIG_ICX) || defined(CONFIG_ICD)

#include "reg.h"

#define L2X0_CACHE_SYNC	0x730

.globl cpu_idle

/*-----------------------------------------------------------------------------
 * Function : cpu_idle
 * Abstruct : Idle the processor (wait for interrupt)
 * Input    : none
 * Returen  : none
 *----------------------------------------------------------------------------*/

cpu_idle:

	/* L2 sync */
	ldr r2, =L2CC_BASE
	dsb

	mov r0, #0x1
	str r0, [r2, #L2X0_CACHE_SYNC]
L2_sync_loop:
	ldr r0, [r2, #L2X0_CACHE_SYNC]
	cmp r0, #0
	bne L2_sync_loop
	
	/* wait for interrupt */
	wfi

	/* return */
	mov pc, lr

#endif /* CONFIG_ICX || CONFIG_ICD */
