/* 2012-07-09: File added by Sony Corporation */
/*
 * icx_dac.h
 *
 * Copyright 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ICX_DAC_H__
#define __ICX_DAC_H__


/***************/
/* Definitions */
/***************/

/* beep period */
#define BEEP_TIME_CONTINUOUS      0 /* continuous */
#define BEEP_TIME_100MS      100000 /* 100ms	  */


/******************/
/* Beep operation */
/******************/
typedef struct {
	void (*power_on)(void);
	void (*power_off)(void);
	void (*enable_mute)(void);
	void (*disable_mute)(void);
	void (*beep_on)(unsigned int);
	void (*beep_off)(void);
	void (*on_boot)(void);
} dac_ops_t;


/**************/
/* Prototypes */
/**************/
extern int  dac_init(void);
extern void dac_exit(void);
extern void dac_enbale_mute(void);
extern void dac_disable_mute(void);
extern void dac_beep_on(unsigned int period);
extern void dac_beep_off(void);
extern void dac_on_boot(void);

#endif /* __ICX_DAC_H__ */
