/* 2012-07-09: File added by Sony Corporation */
/*
 * icx_rtc.h
 *
 * Copyright 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ICX_RTC_H__
#define __ICX_RTC_H__

/*******************/
/* Type definition */
/*******************/

typedef struct {
	int year;

	union {
		int mdhm;

		struct {
			int month  :8; 
			int day    :8; 
			int hour   :8; 
			int minute :8; 
		} e;
	} tm; 
} rtc_date_t;


/**************/
/* Prototypes */
/**************/
int rtc_is_alarm(void);
int rtc_get_date(rtc_date_t *date_buf);


#endif /* __ICX_RTC_H__ */
